import os
import re
import sqlite3
import urllib2
try:
    from BeautifulSoup import BeautifulSoup
except ImportError:
    from bs4 import BeautifulSoup   
import BaseHTTPServer
from SimpleHTTPServer import SimpleHTTPRequestHandler
import threading
import socket
import commands
import shutil
import tempfile
import subprocess
import time
import math
import datetime
import multiprocessing
# I was going to make this python2.7 and python3 compatible
# but I havent implemented it fully. I believe I would only need to
# implement urllib3 and fix imports. Also, the log parser needs to be 
# fixed to capture the urls properly as there are potentially 
# many bugs being missed out on.

# Python 3 imports
try:
    import tkinter as tk
    from tkinter import ttk
    from tkinter import messagebox as message
    from tkinter import filedialog
    from tkinter import scrolledtext as ScrolledText
# Python 2.7 imports
except ImportError:
    import Tkinter as tk
    import ttk
    import tkMessageBox as message
    import tkFileDialog as filedialog
    from ScrolledText import ScrolledText

db_name = 'commits.db'# Hardcoded database name
original_directory = os.getcwd()
if os.name == 'nt':
    dir_slash = "\\"
else:
    dir_slash = "/"
db_name = original_directory+dir_slash+db_name

#print(db_name)
class ServerThread (threading.Thread):
    finished = False
    def __init__(self, local_ip, path_to_host, layout_loc, file_path):
        threading.Thread.__init__(self)
        self.local_ip = local_ip
        self.layout_loc = layout_loc
        self.file_path=file_path       
        #self.host_path = path_to_host.rsplit(dir_slash,1)[0]
        self.host_file = path_to_host.rsplit(dir_slash,1)[1]
        print('path to host: ' + path_to_host)
    def run(self):        
        self.start_server()
       
    def start_server(self):
        try:
            os.chdir(self.layout_loc)
            #self.server_directory = os.getcwd()
            self.HandlerClass = SimpleHTTPRequestHandler
            self.ServerClass  = BaseHTTPServer.HTTPServer
            self.server = self.ServerClass((self.local_ip,8000), self.HandlerClass)
            self.serv_info = self.server.socket.getsockname()
            print "Serving "+self.host_file+" as index.html @ "+str(self.serv_info[0])+":"+str(self.serv_info[1]), "..."
            with open('index.html','w') as f:
                f.write('<script type="text/javascript">window.location.href="'+self.file_path+'"</script>')
            self.finished = True
            self.server.serve_forever() 
            return           
        except Exception as e:
            print(e)
            return
              
         
# The log parser
class LogParser():
    commit_list = []
    entry_count = 0
    #stop_date = 
    
    
    def __init__(self,log_file):
        if os.path.isfile('commits.db'): # There cannot be an existing file named 'commits.db if you plan to parse a new log.'
            message.showerror('error','A file named commits.db already exists, please rename or move your old database file.')
            raise Exception
            #os.remove('commits.db')
        else:
            bugs = ''
            rvn = ''
            url = []
            stop_date = "2012-10-16"

                # the (?ims) is specifying flag optioons: ignore case, multiline (treat \n like characters), s (allows . to be extra greedy)
                # find bug that starts with r followed by any combination of numbers 0-9 that is 6 digits log followed by a space and a pipe
                # pipe is escaped to let python know we are looking for the character | since by default re treats it like a boolean or
                # This is followed by a wild card (.) and told to be greedy (gobble) until it hits a '-' that is repeated between 68-73 times.
                # Its actually 72 times but left some wiggle from for incorrect line terminators
                
            bugs = re.findall('(?ims)(^r[0-9]{6}.*?)-{68,73}', log_file.read())
        
            for bug in bugs:
                # find bug that starts with r followed by any combination of numbers 0-9 that is 6 digits log followed by a space and a pipe
                # pipe is escaped to let python know we are looking for the character | since by default re treats it like a boolean or
                # This is followed by a wild card (.) and told to be greedy (gobble) until up against another escaped |.
                # The next area is where the date/time is located so we wrap that up in paranthesis indicating its a subgroup of the whole
                # expression.  We grab the entire line and stop (? means less greedy) at the next |
                
                bugdate =  re.search('(?ims)r[0-9]{6} \|.*\|(.*?)\|', bug)
                
                #Next we check the match object to see if it contains something.  group(0) is the entire matched expression, group(1) is what is
                #contained with the paranthesis.  We split the string and grab the yyyy-mm-dd and check against the given date
                #if true it breaks out of the loop since we met our end date.
                
                if bugdate != None:
                    date = bugdate.group(1).strip()
                    if date.split(' ')[0] == stop_date:
                        break
                links = re.findall(r'(?ims)https://bugs.webkit.org/show_bug.cgi\?id\=[0-9]+', bug)
                if len(links) > 0:
                    rvn = re.search('(r[0-9]{6}) \|', bug).group(1)
                    if links > 1:
                        for link in links:
                            self.commit_list.append((rvn,link,bug.strip()))
                            self.entry_count += 1
                    else:
                        self.commit_list.append((rvn,links,bug.strip()))
                        self.entry_count += 1

            self.generate_db()

         
    def generate_db(self):
        self.number_errors = 0
        self.error_rvn = []
        db = sqlite3.connect(db_name)
        db.text_factory = str
        cursor = db.cursor()
        cursor.execute("CREATE TABLE logs(id INTEGER PRIMARY KEY AUTOINCREMENT UNIQUE NOT NULL, revision TEXT, url TEXT, info TEXT, restricted INT)")
        for i in self.commit_list:
            try:            
                cursor.execute("INSERT INTO logs(revision, url, info) VALUES(?,?,?)", (i[0],i[1],i[2]))
            except Exception as e:
                self.number_errors += 1
                self.error_rvn.append(i[0])                
                print(e)
        print('Number of errors: ' + str(self.number_errors))
        print('Number of entries: ' + str(self.entry_count))
        for i in self.error_rvn:
            print(i)
            
        db.commit()
        db.close()      
       
def uget(url):
    urllist = [url]
    if urllist[0].find(',') > 0:
        urllist = url.split(',')
    for url in urllist:
        page = urllib2.urlopen(url)
        html = page.read()
        soup  = BeautifulSoup(html)
        title_tag = soup.findAll("title")
    for i in title_tag:
            x=str(i)
            if 'Access Denied' in x:
                return url
            else:
                return None 
    
class HTMLScraper(BeautifulSoup,threading.Thread):
   
    def __init__(self):
        threading.Thread.__init__(self)
        BeautifulSoup.__init__(self)       
        self.denied_urls = []
        self.thread_count = 16
        self.test_max = 320


        
    def run(self):
        db = sqlite3.connect(db_name)
        cursor = db.cursor()
        cursor.execute("Select Count(*) from logs")
        url_count = cursor.fetchone()[0]
        cursor.execute("SELECT * FROM logs")
        urls_checked = float(0)
        urls_found = float(0)
        total_time = 0
        print "Loaded " +str(url_count) + " Bug Records"
        print "Beginning bug check...\nReports every " + str(self.thread_count*5) + " records"
        start_time = time.time()
        results = cursor.fetchall()[:self.test_max]
        url_count = self.test_max
        total_processed = 0
        start_total_time = time.time()

        pool = multiprocessing.Pool(processes = self.thread_count)
        for i in range(0,url_count,self.thread_count):
            try:
                if (url_count - i) > self.thread_count:
                    max_length = self.thread_count
                    #print "MAX LENGTH:", max_length
                else:
                    max_length = url_count - i
                    #print "MAX LENGTH:", max_length
                    
                urllist = [results[i+j][2] for j in range(max_length)]

                for u in pool.imap_unordered(uget, urllist):
                    if u != None:
                        self.denied_urls.append(u)
                        print "Found: ", u
                #time.sleep(1)
                urls_checked += max_length

                if urls_checked % (self.thread_count * 5) == 0:
                        stop_time = time.time()
                        total_time = float((stop_time - start_time ))/ 50  #gets average from last 10
                        urls_remaining = url_count - urls_checked        #secs  #mins                        
                        time_remaining = round((((urls_remaining * total_time) / 60 )  /60),2)
                        time_remaining = str(time_remaining).split('.')
                        hours_remaining = time_remaining[0]
                        minutes_remaining = str((float(time_remaining[1])/100 * 60)).split('.')[0]  # uses percentage to approximate minutes remaining
                        if int(minutes_remaining) < 10:
                            minutes_remaining = '0'+minutes_remaining
                        percentage = round(float((urls_checked/url_count)) * 100,2)
                        total_time = 0
                        print "\nPercent Complete: ",  percentage
                        print "Approximate Time Remaining: " + hours_remaining +":"+minutes_remaining

                        start_time = time.time()

                if urls_checked == url_count:
                    print "\nPercent Complete: 100%"
                    pool.terminate()
            except urllib2.URLError as e:
                print "Exception:", e
                pass
                    

        total_end_time = round(time.time() - start_total_time)/60
        minutes,seconds = str(total_end_time).split('.')
        seconds = round(((int(seconds)/100) * 60),2)
        if seconds < 10:
            total_end_time = str(minutes) + ":0"+str(seconds)
        else:
            total_end_time = str(minutes) + ":"+str(seconds)
        
        print "Total End Time:",total_end_time
        if len(self.denied_urls) > 0:
            print "\nUpdating Database with " + str(len(self.denied_urls)) + " URL's\n"
            for i in self.denied_urls:
                cursor.execute("UPDATE logs SET restricted = ? WHERE url = ?", (1,i))

        db.commit()
        db.close()
        try:
            if root.html_thread == None:
                print "GOT IT"
            print message.showinfo(title="Complete", message="Scanning for restricted bugs is complete")
        except TypeError as e:
            print "Exception:", e
            
        return 

class RootWindow(tk.Tk):
    newthread=False
    html_thread=False
    commit_track_list = []
    def __init__(self,*args,**kwargs):
        tk.Tk.__init__(self, *args, **kwargs)
        self.build_window()

    def build_window(self):
        # Build the Notebook widget
        n = ttk.Notebook(self)
        tab1 = ttk.Frame(n)
        tab2 = ttk.Frame(n)
        tab3 = ttk.Frame(n)
        n.add(tab1,text="Parser")
        n.add(tab2,text="Results")
        n.add(tab3,text="Hosting")
        n.pack(fill="both", expand=True)
    
        # Populate tab1
        self.label1 = ttk.Label(tab1,text="Enter the path to the .txt log file or click Browse below.").grid(
                                column=1,row=1,columnspan=2,padx=10,pady=15)
        self.label2 = ttk.Label(tab1,text="Path:").grid(column=1,row=2,padx=3,pady=10)
        self.log_file_path = ttk.Entry(tab1, width=30)
        self.log_file_path.grid(column=2,row=2,padx=10,pady=10)
        self.browse_btn = ttk.Button(tab1,text="Browse..",command=self.browse_clicked).grid(column=3,row=2,padx=3,pady=10,sticky='w')
        self.label3 = ttk.Label(tab1,text="Once you've provided a valid path above, click on the Parse log button. This will parse the log file\ninto seperate commit entries and generate a database file to work with. This will take a few seconds").grid(
                                column=1,row=3,columnspan=6,padx=10,pady=10)
      
        self.parse_btn = ttk.Button(tab1,text="Parse log",width=20,command=self.parse_clicked)
        self.parse_btn.grid(column=1,row=4,padx=10,pady=10)
        self.label4 = ttk.Label(tab1,text="Once parsing/database generation completes, click on the Scan for restricted button. This will attempt\nto scan for all bugs that are protected. This will take a very long time. After this completes,\nswitch to the results tab at the top.").grid(column=1,row=5,columnspan=6,padx=10,pady=10)
        self.scan_btn = ttk.Button(tab1,text="Scan for restricted bugs",width=20,command=self.scan_clicked)
        self.scan_btn.grid(column=1,row=6,padx=10,pady=10)
        self.label5 = ttk.Label(tab1,text="Optionally, you can strip the database of all commits which are not marked as restricted. This will\nincrease performace in the results view. Or skip this step and preserve all the database commit entries.\nThis will take a few seconds.").grid(column=1,row=7,columnspan=6,padx=3,pady=10)
        self.stripdb_btn = ttk.Button(tab1,text="Strip database",width=20,command=self.stripdb_clicked)
        self.stripdb_btn.grid(column=1,row=8,padx=10,pady=10)

        # Populate tab2
        self.frame1 = ttk.Frame(tab2)
        self.frame2 = ttk.Frame(tab2)        
        self.commit_view_box = tk.Listbox(self.frame1, height=39,width=35)
        self.commit_view_box.pack(fill='both',expand=True)
        self.commit_view_box.bind("<<ListboxSelect>>", self.commit_selected)
        self.commit_view_scrollbar = ttk.Scrollbar(self.commit_view_box,orient='vertical')
        self.commit_view_scrollbar.pack(side='right',fill='y')
        self.commit_view_box.config(yscrollcommand=self.commit_view_scrollbar.set)
        self.commit_view_scrollbar.config(command=self.commit_view_box.yview)
        self.results_box = ScrolledText(self.frame2,height=42,width=75,wrap='word')        
        self.results_box.pack(fill='both',expand=True)
        self.refresh_btn = ttk.Button(self.frame1,text='Refresh list',width=20,command=self.refresh_clicked)
        self.refresh_btn.pack(side='bottom',padx=50)
        self.frame1.pack(side='left',fill='both',expand=True)
        self.frame2.pack(side='right',fill='both',expand=True)

        # Populate tab3
        self.label6 = ttk.Label(tab3,text="Please enter your local IP address into the box below. You can attempt to grab your\nIP address automatically by clicking the Get my IP button.").grid(column=1,row=1,columnspan=4,padx=10,pady=10)
        self.localip_entry = ttk.Entry(tab3,width=30)
        self.localip_entry.grid(column=1,row=2,padx=10,pady=10)
        self.getip_btn = ttk.Button(tab3,text="Get my IP",width=20,command=self.getip_clicked)
        self.getip_btn.grid(column=2,row=2,padx=10,pady=10)
        self.stop_srvr_btn = ttk.Button(tab3,text="Stop server",width=20,command=self.stop_srvr_clicked)
        self.stop_srvr_btn.grid(column=2,row=9,padx=5,pady=10)
        self.label7 = ttk.Label(tab3,text="Next, provide the path to the layout tests directory below.").grid(column=1,row=3,columnspan=2,padx=10,pady=5,sticky='w')
        self.label8 = ttk.Label(tab3,text="Path:").grid(column=1,row=4,padx=10,pady=10,sticky='w')
        self.layouttests_path = ttk.Entry(tab3, width=30)
        self.layouttests_path.grid(column=1,row=4,padx=50,pady=10,sticky='e')
        self.browse2_btn = ttk.Button(tab3,text="Browse..",command=self.browse2_clicked)
        self.browse2_btn.grid(column=2,row=4,padx=3,pady=10,sticky='w')
        self.label9 = ttk.Label(tab3,text="Now, simply switch to the results view and copy/paste the location of the layout test\nfile below. Then click the Host file button, This will rename and host the file as\nindex.html on port 8000, once hosting, point the console browser to\nyour_local_ip_address:8000. In theory you could do this over and over and just refresh\nthe browser each time you host a new file but this could cause a dirty\nenvironment for the tests. Im really not sure though. Be sure to stop the server when done").grid(column=1,row=7,columnspan=4,padx=10,pady=10)
        self.label10 = ttk.Label(tab3,text="Paste:").grid(column=1,row=8,padx=10,pady=10,sticky='w')
        self.hostfile_entry = ttk.Entry(tab3, width=30)
        self.hostfile_entry.grid(column=1,row=8,padx=50,pady=10,sticky='e')
        self.host_btn = ttk.Button(tab3,text="Host file",width=20,command=self.host_file_clicked)
        self.host_btn.grid(column=1,row=9,padx=5,pady=10)

    # Behavior for button clicks in all tabs of root window.
    def browse_clicked(self):
        log_path = filedialog.askopenfilename()
        self.log_file_path.delete('0',tk.END)
        self.log_file_path.insert('end',log_path)
   
    def browse2_clicked(self):        
        tests_directory = filedialog.askdirectory()
        self.layouttests_path.delete('0',tk.END)
        self.layouttests_path.insert('end',tests_directory)

    def start_server(self, path_to_host, local_ip, layout_loc, file_path):
        if not self.newthread:
                self.newthread = ServerThread(local_ip, path_to_host, layout_loc, file_path)
                self.newthread.daemon=True
                self.newthread.start()
                while True:
                    
                    if self.newthread.finished == True:
                        message.showinfo('Done','Now hosting '+ path_to_host + ' as\nindex.html @ '+str(self.newthread.serv_info[0])+":"+str(self.newthread.serv_info[1]))
                        break
                        
        else:
            message.showerror('Error','Server is already running.')
            print(' server is runnig')
     
    def stop_srvr_clicked(self):
        if self.newthread:
            self.newthread.server.shutdown()
            self.newthread = False
            print('server stopped')
        else:
            print('server not found running')

    
    def getip_clicked(self):
        ip = ''
        if os.name == 'posix':
            ip = commands.getoutput("hostname -I")
            print(ip)
        elif os.name == 'nt':
            ip = socket.gethostbyname(socket.gethostname())
            print(ip)
        else:
            print('couldnt get local ip')
        self.localip_entry.delete('0',tk.END)
        self.localip_entry.insert('end',ip)
            
         

    def parse_clicked(self):
        try:
            log_path = open(self.log_file_path.get())
        except Exception as e:
            print(e)
            log_path=None
        if log_path != None:
            try:             
                self.parsed_log = LogParser(log_path)
                self.commit_list = self.parsed_log.commit_list
                self.entry_count = self.parsed_log.entry_count
                message.showinfo('Complete','Operation is complete')
            except Exception as e:
                print(e)
                message.showerror('Error','Something went wrong parsing the log. Check console output.')
        else:
            message.showerror('Error','You did not provide a file name or the file name is invalid.')

    def scan_clicked(self):
        if not self.html_thread:
                self.html_thread = HTMLScraper()
                self.html_thread.daemon=True
                self.html_thread.start()

    def refresh_clicked(self):
        db = sqlite3.connect(db_name)
        cursor = db.cursor()
        cursor.execute("SELECT * FROM logs WHERE restricted == 1")
        self.commit_view_box.configure(state='normal')
        self.commit_view_box.delete('0',tk.END)
        for i in cursor:
            self.commit_view_box.insert('end',i[1])
            self.commit_track_list.append(i[1])
        db.close()

    def stripdb_clicked(self):
        
        db_id = []
        db = sqlite3.connect(db_name)
        cursor = db.cursor()
        cursor.execute("SELECT * FROM logs")
        try:
            for i in cursor:
                if i[4] != 1:
                    db_id.append(i[0])
            for i in db_id:
                cursor.execute("DELETE FROM logs WHERE id = ?",(str(i),))
        except Exception as e:
            print(e)
            message.showerror('Error','Something went wrong stripping the database.')
        message.showinfo('Complete','Operation complete')
        db.commit()
        db.close()

    def host_file_clicked(self):
        self.stop_srvr_clicked()
        local_ip = self.localip_entry.get()
        layout_loc = self.layouttests_path.get()
        if os.name =='nt':
                    layout_loc=layout_loc.replace('/',dir_slash)
        if local_ip != '':
            if layout_loc != '':
                file_path = self.hostfile_entry.get()
                if os.name =='nt':
                    file_path=file_path.replace('/',dir_slash)
                alt_file_path = layout_loc + dir_slash + file_path
                print('the file path : ' + file_path)
                if file_path != '':
                    try:
                        if os.path.isfile(alt_file_path):
                            self.start_server(alt_file_path, local_ip, layout_loc, file_path)
                            #self.copy_host_file(alt_file_path)
                            print('found file')
                            #message.showinfo('Done','Now hosting '+ alt_file_path)
                        else:
                            message.showerror('Error','File was not found.')
                    except Exception as e:
                        print(e)                       
                else:
                    message.showerror('Error','All fields are required.')    
            else:
                message.showerror('Error','All fields are required.')
        else:
            message.showerror('Error','All fields are required.')
    '''
    def copy_host_file(self,file_to_host):
        filename = "index.html"
        try:
            shutil.copyfile(file_to_host, filename)
        except Exception as e:
            print(e)
    '''
    # Behavior for the commit_view_box listbox selections.
    def commit_selected(self,event):
        self.results_box.delete('0.0',tk.END)    
        current = self.commit_view_box.curselection()
        activate_current = self.commit_view_box.activate(current)
        get_selection = current[0]
        db = sqlite3.connect(db_name)
        cursor = db.cursor()
        cursor.execute("SELECT * FROM logs WHERE revision = ?",(self.commit_track_list[get_selection],))
        for i in cursor:
            self.results_box.insert('end',i[3])            
        db.close()



if __name__ == '__main__':
    multiprocessing.freeze_support()
    root = RootWindow()
    root.mainloop()
    


